/*
 * N903_reg.h
 *
 *  Created on: 2014/2/13
 *      Author: 300210
 *
 *  Please put all Andes native registers in this file
 */

#ifndef N903_REG_H_
#define N903_REG_H_

#include "nds32_intrinsic.h"
#include "const.h"

/*
 * Nssystem register禡gmacro
 * Ъ`NGaudio registerAܦhݩuser registerAݭnzL __nds32__mfusr, __nds32__mtusrӦs
 */
#define N903_GetBit(reg,bits)		((__nds32__mfsr(reg) & bitmask(bits)) >> bitoffset(bits))
#define N903_SetBit(reg,bits,val)	__nds32__mtsr((__nds32__mfsr(reg) & (~bitmask(bits))) | (((val) << bitoffset(bits)) & bitmask(bits)), reg)

#define N903_Write(reg,val)		__nds32__mtsr(val,reg)
#define N903_Read(reg)			__nds32__mfsr(reg)

/*
 * }global interrupt enable
 * Coͤ_ɡAGIE|۰ʳQApGƱ󰪶_o͡ANn}GIE
 */
inline void GIE_ENABLE()
{
	__nds32__setgie_en();
	__nds32__dsb();
}

/*
 * global interrupt enable
 */
inline void GIE_DISABLE()
{
	__nds32__setgie_dis();
	__nds32__dsb();
}

/*
 * software interruptAGIE=1ɷ|Woͤ_
 */
inline void gen_swi()
{
	N903_SetBit(NDS32_SR_INT_PEND, BITS(16,16), 1);
	__nds32__dsb();
}

/*
 * Msoftware interruptAiJsoftware ISRA̦nWMA
 */
inline void clear_swi()
{
	N903_Write(NDS32_SR_INT_PEND, 0);
	__nds32__dsb();
}


#define NDS32_FMEMCPY(dst, src, size) \
	__asm__ __volatile__( \
		"sethi   $r3, hi20(%2)       \n\t" \
		"ori     $r3, $r3, lo12(%2)  \n\t" \
		"sethi   $r1, hi20(%0)       \n\t" \
		"ori     $r1, $r1, lo12(%0)  \n\t" \
		"sethi   $r2, hi20(%1)       \n\t" \
		"ori     $r2, $r2, lo12(%1)  \n\t" \
		"1:\n\t" \
		"lwi.bi  $r0, [$r2], 4       \n\t" \
		"swi.bi  $r0, [$r1], 4       \n\t" \
		"addi    $r3, $r3, -4        \n\t" \
		"bgtz    $r3, 1b             \n\t" \
		::"i"(dst),"i"(src),"i"(size):"$r0", "$r1","$r2","$r3")



/*
 * Configuration
 */
//NDS32_SR_CPU_VER,		(read only)
#define F_cpu_perf_ext	BITS(0,0)	// performance extension exists
#define F_cpu_16_ext	BITS(1,1)	// 16-bit extension exists
#define F_cpu_perf2_ext	BITS(2,2)	// performance extension 2 exists
#define F_cpu_has_fpu	BITS(3,3)	// COP/FPU extension exists
#define F_cpu_str_ext	BITS(4,4)	// string extension exists
#define F_cpu_rev		BITS(23,16)	// revision number (def=0x10)
#define F_cpu_id		BITS(31,24)	// major CPU version (def=0x09)

//NDS32_SR_ICM_CFG,		(read only)
#define F_icm_iset		BITS(2,0)	// Icache cachelines per way, 0=64, 1=128,..., 6=4096 (def=IM)
#define F_icm_iway		BITS(5,3)	// Icache ways, 0=direct-mapped, 1~8=2~8 ways (def=IM)
#define F_icm_isize		BITS(8,6)	// Icache line size, 0=no cache, 1=8 bytes,..., 5=128 bytes (def=IM)
#define F_icm_lock		BITS(9,9)	// 1=support locking (def=1)
#define F_icm_ilmb		BITS(12,10)	// num of on-chip instruction local memory base, 0=No ILMB, 1=One ILMB (def=IM)
#define F_icm_align		BITS(14,13)	// ILM base alignment, 0=1MB-aligned, 1=LM-size-aligned, LM-size is power of 2 (def=1)

//NDS32_SR_DCM_CFG,		(read only)
#define F_dcm_dset		BITS(2,0)	// Dcache cachelines per way, 0=64, 1=128,..., 6=4096 (def=IM)
#define F_dcm_dway		BITS(5,3)	// Dcache ways, 0=direct-mapped, 1~8=2~8 ways (def=IM)
#define F_dcm_dsize		BITS(8,6)	// Dcache line size, 0=no cache, 1=8 bytes,..., 5=128 bytes (def=IM)
#define F_dcm_lock		BITS(9,9)	// 1=support locking (def=1)
#define F_dcm_dlmb		BITS(12,10)	// num of on-chip data local memory base, 0=No ILMB, 1=One ILMB, 2=Two ILMB support double buffer (def=IM)
#define F_dcm_align		BITS(14,13)	// DLM base alignment, 0=1MB-aligned, 1=LM-size-aligned, LM-size is power of 2 (def=IM)
#define F_dcm_extdlm	BITS(15,15)	// data local memory is external or not, 0=internal DLM, 1=external DLM (def=IM)

//NDS32_SR_MMU_CFG,		(read only)
#define F_mmu_func			BITS(1,0)	// 0=no memory management, 1=protection unit, 2=TLB MMU (def=IM)
#define F_mmu_pro_ver		BITS(6,2)	// version number of the MMU protection scheme
#define F_mmu_ful_tlb		BITS(7,7)	// 1=TLB is a full-associative structure
#define F_mmu_tlb_size		BITS(14,8)	// if the TLB is full-associative, the number of TLB entries
#define F_mmu_tlb_ways		BITS(10,8)	// if the TLB isn't full-associative, 0=direct-mapped, 1~7=2~8 ways
#define F_mmu_tlb_sets		BITS(13,11)	// if the TLB isn't full-associative, 0~6=4~256 sets per way
#define F_mmu_8kb_page		BITS(15,15)	// under 4kb config, 1=support 8kb page, 0=not support
#define F_mmu_page_size		BITS(23,16)	// supported page sizes, LSB to MSB: 16KB, 64KB, 256KB, 1MB, 4MB, 16MB, 64MB, 256MB
#define F_mmu_tlb_lock		BITS(24,24)	// TLB locking support, 1=support, 0=not support
#define F_mmu_hw_tblwalk	BITS(25,25)	// hardware page table walker, 1=implemented, 0=no
#define F_mmu_def_be		BITS(26,26)	// default endian will copy to F_psw_be on reset and interrupt, 0=little endian, 1=bit endian (def=IM)
#define F_mmu_nta_num		BITS(27,27)	// number of partition for non-translated attributes, 0=2 from VA(31), 1=4 from VA(31,30) (def=1)
#define F_mmu_inv_tlb		BITS(28,28)	// 1=software-invisible TLB that includes additional PTEs exists
#define F_mmu_vplt			BITS(29,29)	// 1=VLPT feature is implemented, for fast TLB fill handling
#define F_mmu_nta_map		BITS(30,30)	// 1=implement non-translated VA to PA mapping function (def=1)
#define F_mmu_dev_def_be	BITS(31,31)	// device register default endian will be copy to F_psw_dev_be on reset and interrupt (def=IM)

//NDS32_SR_MSC_CFG,		(read only)
#define F_msc_edm		BITS(0,0)	// 1=embedded debug module is implemented (def=IM)
#define F_msc_dma		BITS(1,1)	// 1=local memory DMA is implemented (def=0)
#define F_msc_mon		BITS(2,2)	// 1=performance monitoring machanism is implemented (def=0)
#define F_msc_hs_mem	BITS(3,3)	// 1=high speed memory port exists (def=0)
#define F_msc_trace		BITS(4,4)	// 1=debug tracer unit is implemented (def=0)
#define F_msc_div		BITS(5,5)	// 1=DIV/DIVS instruction exists (def=1)
#define F_msc_mul		BITS(6,6)	// 1=multiply instruction exists (def=1)
#define F_msc_audio		BITS(8,7)	// 0=audio extension not supported, 3=both 24-bit and 32-bit audio extensions are supported (def=0)
#define F_msc_l2c		BITS(9,9)	// 1=L2 unified cache is implemented (def=0)
#define F_msc_gpr16		BITS(10,10)	// 1=reduced register config is implemented (def=IM)
#define F_msc_adr24		BITS(11,11)	// 1=reduced address space to 24-bit (def=0)
#define F_msc_intlc		BITS(12,12)	// 0=int level 1~3 is implemented, 1=int level 1~2 is implemented (def=IM)
#define F_msc_basev		BITS(15,13)	// version of baseline, 0=ver1, 1=ver2 (def=1)
#define F_msc_nod		BITS(16,16)	// Dx register exist or not, 0=exists, 1=not exist. When MISC.AUDIO=1, this bit must be 0 (def=IM)
#define F_msc_depreg	BITS(17,17)	// implementation-dependent register detection scheme version, 0=ver0 non-scalable, 1=ver1 scalable
#define F_msc_ownreg	BITS(18,18)	// 1=the first implementation-dependent register of SR encoding {2, 15, 0} exists
#define F_msc_ifc		BITS(19,19)	// 1=Inline Function Call (IFC) supported
#define F_msc_mcu		BITS(20,20)	// 1=This processor belongs to MCU family, architecture version has suffix "m", ex: V3m
#define F_msc_shadow	BITS(23,21)	// 1=One shadow stack pointer for privileged mode, 0=Shadow registers are not implemented.

//NDS32_SR_CORE_ID,		(read only)
#define F_core_id		BITS(6,0)	// in multi-core system, used to distinguish each core (def=IM)

//NDS32_SR_FUCOP_EXIST	(read only) F_cpu_has_fpu=1~sbȦs
#define F_cop_0_exist	BITS(0,0)	// Coprocessor #0 exists
#define F_cop_1_exist	BITS(1,1)	// Coprocessor #1 exists
#define F_cop_2_exist	BITS(2,2)	// Coprocessor #2 exists
#define F_cop_3_exist	BITS(3,3)	// Coprocessor #3 exists
#define F_cop_fpu		BITS(31,31)	// Coprocessor #0 is FPU when Coprocessor #0 exists


/*
 * Interruption
 */
//NDS32_SR_PSW,
#define F_psw_gie			BITS(0,0)	// 0=disable interrupt (NMI cant be disabled by this bit), 1=enable all interrupt (def=0)
#define F_psw_intl			BITS(2,1)	// interrupt stack level (def=1)
#define F_psw_pom			BITS(4,3)	// processor operation mode, 0=user, 1=superuser (def=1)
#define F_psw_be			BITS(5,5)	// 1=big endian mode for data memory access (def=F_mmu_def_endian)
#define F_psw_it			BITS(6,6)	// 1=enable instruction address translationC_ũWɮɡA|Q]0AҦpLv0->Lv1Lv1->Lv2 (def=0)
#define F_psw_dt			BITS(7,7)	// 1=enable data address translationA_ŤWɮɷ|]0 (def=0)
#define F_psw_ime			BITS(8,8)	// instruction machine error exceptionoͮɷ|]1AinstructionOq֨ϰŪX (def=0)
#define F_psw_dme			BITS(9,9)	// data machine error exceptionoͮɷ|]1 (def=0)
#define F_psw_dex			BITS(10,10)	// debug exceptionoͮɳ]1 (def=0)
#define F_psw_hss			BITS(11,11)	// 0=wBA_oͮɷ|0, 1=wB}A_oͮɷ|]DSSIM (def=0)
#define F_psw_dev_be		BITS(12,12)	// MMU_CTL.DREE=1ɡAbitNregister spaceendianA1=device register big endian (def=F_mmu_reg_def_end)
#define F_psw_aen			BITS(13,13)	// 1=audio special features are enabled (def=0)
#define F_psw_wbna			BITS(14,14)	// 0=write-back memory with write-allocation policy, 1=write back memory with no-write-allocation policy (def=0)
// V3 architecture special fields:
#define F_psw_ifcon			BITS(15,15)	// 1=the program is executed in an IFC sequence
#define F_psw_cpl			BITS(18,16)	// Current Priority Level (CPL), 0=No interrupts are allowed, 1~3=allow priority 0/0~1/0~2, 7=allow priority 0~6

//NDS32_SR_IPSW,
	/* @PSWshadow registerAMPSWP˪A_0->11->2ɡA|ƻsPSW
	 * Ѥ_1->02->1ɷ|g^PSWAҦw]ȳOdont careA]_oͫᰨW|Qл\
	 */
	// V3 architecture special fields in IPSW:
#define F_ipsw_spadj		BITS(19,19)	// 1=Stack adjustment is needed because it is not 8-byte aligned. Stack pointer is deducted by 4 when entering exceptions and added by 4 when leaving exceptions.

//NDS32_SR_P_IPSW,
	/* @IPSWshadow registerA|b_1->2ɽƻsIPSWȡFѤ_2->1ɷ|g^IPSW
	 * Ҧw]ȳOdont careA]_oͫᰨW|Qл\
	 */

//NDS32_SR_IVB,
#define F_ivb_evic		BITS(13,13)	// 1=external interrupt controller mode (def=0)
#define F_ivb_esz		BITS(15,14)	// size of vector entry, 0~3=4B/16B/64B/256B (def=1)
#define F_ivb_ivbase	BITS(31,16)	// base physical address of interrupt vector tableAO64KB (def=IM)
// V3 architecture special fields:
#define F_ivb_priority	BITS(0,0)	// 1=Programmable priority, 0=Fixed priority
#define F_ivb_nivic		BITS(2,1)	// Number of input for IVIC, 0~3=6/2/10/16 input sources

//NDS32_SR_EVA,		(read only)
	/* exceptionoͮɡAxsoͪvirtual address
	 * pGexceptionOOXAhsOɪIPCȡFpGOƲͪexceptionAsOƦ}
	 */

//NDS32_SR_P_EVA,		(read only)
	/* _q1->2ɷ|ƻsEVAȡAѤ_2->1ɷ|Nȼg^EVA
	 */

//NDS32_SR_ITYPE,		(read only)
#define F_itype_excep	BITS(3,0)	// General exception type
#define F_itype_inst	BITS(4,4)	// 1=ҥ~instruction fetchy, 0=ҥ~ѸƦsy
#define F_itype_swid	BITS(30,16)	// BREAKBBREAK16BSYSCALLBTRAP|ӫOҫwSWID
// V3 architecture special fields:
#define F_itype_vector	BITS(7,5)	// Vector indicates the entry point location of the exception
#define F_itype_impexc	BITS(8,8)	// Imprecise Exception flag, DEX=1ӥBoimprecise exceptionɳ]1
#define F_itype_supexc	BITS(9,9)	// Suppressed Exception flag, DEX=1ӥBosuppressed exceptionɳ]1
#define F_itype_subtype	BITS(19,16)	// oarithmetic exception, 1=H0(DIV,DIVS), 2=overflow(DIVS)
#define F_itype_cpid	BITS(21,20)	// oarithmetic exceptionɡAOcoreoͪ

//NDS32_SR_P_ITYPE,
	// ITYPEshadow registerAb_1->2ɷ|ƻsITYPE

//NDS32_SR_MERR,
	/* omachine error exceptionɡAΨxsTAѹ@Mw
	 * ݭnshadow registerA]machine errorӱ_o
	 */

//NDS32_SR_IPC,		interrupt PC, _0->11->2ɽƻsPCȡA2->11->0ɼg^PC
//NDS32_SR_P_IPC,	previous IPC, _1->2ɽƻsIPCȡA2->1ɼg^IPC
//NDS32_SR_OIPC,	overflow IPC, _2->3ɽƻsPC
//NDS32_SR_P_P0,	previous P0, _1->2ɽƻsP0ȡA2->1ɼg^P0
//NDS32_SR_P_P1,	previous P1, _1->2ɽƻsP1ȡA2->1ɼg^P1

//NDS32_SR_INT_MASK,
#define F_int_hw_mask	BITS(5,0)	// 1=enable hardware interrupt 5~0 (def=0)AbV3 baselineܦBITS(15,0)
#define F_int_sw_mask	BITS(16,16)	// 1=enable software interrupt (def=0)
#define F_int_alz		BITS(29,29)	// 1=All zero opcode reserved instruction exception is enabled
#define F_int_idivze	BITS(30,30)	// 1=enable arithmetic exception (def=1)
#define F_int_dssim		BITS(31,31)	// Default Single Stepping Interruption Mask, _oͮɡAif (F_psw_hss==1) F_psw_hss = F_int_dssim (def=1)

//NDS32_SR_INT_PEND,
#define F_int_hw_st		BITS(5,0)	// (read only) hardware interrupt 5~0oͦӥBBz
#define F_int_evicreq	BITS(5,0)	// (read only) current interrupt priority level requested by EVIC
#define F_int_sw_trig	BITS(16,16)	// gJ1=software interrupto͡AgJ0=Bzsoftware interrupt

// V3 architectureAåBF_msc_shadow=1ɤ~䴩UCӼȦs
//NDS32_SR_SP_USR,		_oͮɡApGPWM=0(user mode)A|NSPȦso
//NDS32_SR_SP_PRIV,		_oͮɡApGPWM=1(super mode)A|NSPȦso

// V3 architecture~䴩UCӼȦs
//NDS32_SR_INT_PRI,		V3䴩16IVIC_ACӤ_2 bitspriorityA0=̰A3=̧C(w])
//NDS32_SR_INT_CTRL,
#define F_int_ppl2fix	BITS(0,0)	// 1=Ϥ_priorityۦPAiHpreemptAΨӻPV2ۮe
#define F_int_legacy	BITS(1,1)	// 1=IVIC_ƶqܦ6ӡAۮeV2



/*
 * MMU System
 */
//NDS32_SR_MMU_CTL,
#define F_mmu_pagesz	BITS(0,0)	// default minimum page size is 0=4KB, 1=8KB (def=0)
#define F_mmu_ntc0		BITS(2,1)	// non-translated cache memory attribute for partition 0 (def=0)
#define F_mmu_ntc1		BITS(4,3)	// non-translated cache memory attribute for partition 1 (def=0)
#define F_mmu_ntc2		BITS(6,5)	// non-translated cache memory attribute for partition 2 (def=0)
#define F_mmu_ntc3		BITS(8,7)	// non-translated cache memory attribute for partition 3 (def=0)
	// 0=non-cacheable/non-coalesable, 1=non-cacheable/coalesable, 2=cacheable/write-back, 3=cacheable/write-through
#define F_mmu_tlblock	BITS(9,9)	// TLB all-lock resolution, 0=machine error, 1=random/LRU replacement
#define F_mmu_mpziu		BITS(10,10)	// 1=multiple page size in use, Hardware TLB will perform TLB search for the PTE of large page size
#define F_mmu_ntm0		BITS(12,11)	// non-translated VA to PA[31,30] mapping for partition 0 (def=0)
#define F_mmu_ntm1		BITS(14,13)	// non-translated VA to PA[31,30] mapping for partition 1 (def=1)
#define F_mmu_ntm2		BITS(16,15)	// non-translated VA to PA[31,30] mapping for partition 2 (def=2)
#define F_mmu_ntm3		BITS(18,17)	// non-translated VA to PA[31,30] mapping for partition 3 (def=3)
#define F_mmu_dree		BITS(19,19)	// device register endian control enable (def=IM)
	// 0=ϥοWߪdevice endian, F_psw_beMw
	// 1=(C=0&NTC=0)ɨϥdevice endian, LpF_psw_be

//NDS32_SR_L1_PPTB,		ݭnhardware page table walker䴩ɡAȦs~
#define F_pptb_hptwk	BITS(0,0)	// 1=hardware page table walker enabled (def=1)
#define F_pptb_base		BITS(31,12)	// the first level physical page table base address. It is 4KB-aligned

//NDS32_SR_TLB_VPN,		ݭnMMU䴩ɡAȦs~
	/* TLBgJɡAȦsOpage translation entryvirtual page number(VPN)
	 * TLBŪɡAȦsOŪXVPN
	 * TLB exceptionoͮɡAȦs|令exception VPN
	 * BITS(31,12) = 4KB-aligned VPN
	 */

//NDS32_SR_TLB_DATA,	ݭnMMU䴩ɡAȦs~
	/* TLBؼмgJAȦsNOngJTLBpage translation entry(PTE)
	 * TLBŪAȦsOŪXpage translation entry(PTE)
	 * pGOTLBHgJAPTEƷ|sgeneral registerAӤ|sȦs
	 */
#define F_pte_V			BITS(0,0)	// PTE is valid and present
#define F_pte_M			BITS(3,1)	// svALv|oRead/Write Protection Violation
	/* MMU V1
	 * the privilege of user/superuse is: 1=read/read, 2=read/write, 3=write/write, 5=no/read, 7=no/write
	 * vuload/storeOA|instruction fetch and execution
	 * MMU V2
	 * the privilege of user/superuse is: 0=no/write, 1=read/read, 2=read/write, 3=write/write, 5=no fetch/read, 7=no fetch/write
	 * Ȭ4/6ɷ|fetchAȬ0~3ɭload/storeO
	 */
#define F_pte_D			BITS(4,4)	// 0=a store to this page generates a Page Modified Exception, 1=no exception
#define F_pte_X			BITS(5,5)	// 1=This page is executable, 0=fetch causes Non-Executable Page exception
#define F_pte_A			BITS(6,6)	// 1=Any access to this page generates Access Bit exception
#define F_pte_G			BITS(7,7)	// 1=This page is shared across contexts
#define F_pte_C			BITS(10,8)
	/*
	 * 0 = device space
	 * 1 = device space, write bufferable / coalescable
	 * 2 = non-cacheable memory
	 * 4 = cacheable, write-back, write-allocate memory
	 * 5 = cacheable, write-through, no-write-allocate memory
	 * 6 = cacheable, non-shared, write-back, write allocate memory
	 * 7 = cacheable, non-shared, write-through, no-write-allocate memory
	 */
#define F_pte_phypage	BITS(31,12)	// Physical Page Number of a page

//NDS32_SR_TLB_MISC,	ݭnMMU䴩ɡAȦs~
	/* TLBŪɡAȦsmcontext IDpage sizeFTLBgJɡANݭngJcontext IDpage size
	 * context IDتOקKcontext switchTLB flush|yB~OAOS|tdCcontext switchCID
	 * ]|vTPTEjMAҥHܦɡATLBAάOglobal PTE
	 */
#define F_pte_pagesz	BITS(3,0)	// page size of a PTE entry, 䴩jpbF_mmu_page_size
#define F_pte_cid		BITS(12,4)	// current context id

//NDS32_SR_ILMB,		 F_icm_ilmb != 0 Ȧs~
#define F_ilmb_en		BITS(0,0)	// 1=enable instruction local memory (def=IM)
#define F_ilmb_size		BITS(4,1)	// (read only) 0~8=size 4KB~1024KB (def=IM)
#define F_ilmb_ibpa		BITS(31,10)	// base physical address of ILM, aligned to ILM size (def=IM)

//NDS32_SR_DLMB,		 F_dcm_dlmb != 0 Ȧs~
#define F_dlmb_en		BITS(0,0)	// 1=enable data local memory (def=0)
#define F_dlmb_size		BITS(4,1)	// (read only) 0~8=size 4KB~1024KB (def=IM)
#define F_dlmb_2buf		BITS(5,5)	// 1=enable double buffer mode (def=0)
	// bdouble bufferҦUADLM|A@uprocessorΡAt@uDMA
	// ܦbit|yDLMƵLġAݭnslƤ@
#define F_dlmb_dbb		BITS(6,6)	// which bank of double buffer is used by processor, 0=bank0, 1=bank1 (def=0)
#define F_dlmb_dpba		BITS(31,10)	// base physical address of DLM, aligned to DLM size (def=dont care)

//NDS32_SR_CACHE_CTL,	(F_icm_isize != 0 || F_dcm_dsize != 0) ɦȦs~
#define F_icache_en		BITS(0,0)	// 1=enable Lv1 instruction cache (def=0)
#define F_dcache_en		BITS(1,1)	// 1=enable Lv1 data cache (def=0)
#define F_icache_lock	BITS(2,2)	// controls I-cache all-lock resolution scheme
	// 0=machine error, 1=changes a cacheable request to an un-cacheable request (def=0)
#define F_dcache_lock	BITS(3,3)	// controls D-cache all-lock resolution scheme
	// 0=machine error, 1=changes a cacheable request to an un-cacheable request (def=0)
#define F_dcache_crit	BITS(4,4)	// 1=enable D-cache critical word forwarding (def=1)
#define F_dcache_miss	BITS(5,5)	// 1=enable D-cache concurrent miss and write-back processing (def=1)



/*
 * DMA Control: 䴩DMA\AoǼȦs~
 */
//NDS32_SR_DMA_CFG,		(read only)
#define F_dma_chnum		BITS(1,0)	// 0=1 DMA channel, 1=2 DMA channels
#define F_dma_unea		BITS(3,3)	// 1=Un-aligned External Address transfer feature is implemented
#define F_dma_2det		BITS(4,4)	// 1=2-D Element Transfer feature is implemented
#define F_dma_ver		BITS(31,16)	// the DMA architecture and implementation version

//NDS32_SR_DMA_GCSW,
#define F_dma0_state	BITS(2,0)	// (read only) DMA channel 0 state: 0=idle, 1=run, 2=pended, 3=stop/error, 4=complete
#define F_dma1_state	BITS(5,3)	// (read only) DMA channel 1 state: 0=idle, 1=run, 2=pended, 3=stop/error, 4=complete
#define F_dma0_int		BITS(12,12)	// (read only) 1=an interrupt has been generated from DMA channel 0
#define F_dma1_int		BITS(13,13)	// (read only) 1=an interrupt has been generated from DMA channel 1
#define F_dma_enable	BITS(31,31)	// 0=disable, 1=enable

//NDS32_SR_DMA_CHNSEL,	BITS(1,0)	0=Channel 0 is selected, 1=Channel 1 is selected
	// DMA registeruwDMA channelAMwchannel

//NDS32_SR_DMA_ACT,		BITS(1,0)	uDMA channel, 0=no action, 1=start transfer, 2=stop transfer, 3=reset status/error
	/*
	 * start: Aqidleܦstop/errorApGLchannelSbrunAochannelN}lrunApGLchannelbrunANܦpended
	 * stop: Aqrunpendedܦstop
	 * reset: Aqstop/completeܦ^idle
	 */

//NDS32_SR_DMA_SETUP,	uDMA channelAbrun/pendedAUgJȦsA|yDMA Transfer Disruption error
#define F_dma_lm		BITS(0,0)	// 1=DLM is selected for DMA transfer, 0=ILM is selected
#define F_dma_tdir		BITS(1,1)	// 0=From external memory to LM, 1=From LM to external memory
#define F_dma_tes		BITS(3,2)	// Transfer Element Size: 0=byte ,1=half-word, 2=word, 3=double-word
#define F_dma_estr		BITS(15,4)	// DMAǿ馨\A~OЭnʦh֡A]0ɴN|
	// b2-D ElementҦAoӭȩwqwidth strideAt~ٻݭnwqheight stride
#define F_dma_cie		BITS(16,16)	// 1=interrupt enable on completion
#define F_dma_sie		BITS(17,17)	// 1=interrupt enable on explicit stop
#define F_dma_eie		BITS(18,18)	// 1=interrupt enable on error
#define F_dma_uea		BITS(19,19)	// 1=enable Un-aligned External Address (UEA) Feature
#define F_dma_2de		BITS(20,20)	// 1=enable 2-D External Transfer(2DET) feature
#define F_dma_ca		BITS(23,21)	// Cacheability attribute of external memory access
	/* 0=Device space
	 * 1=Device space, write bufferable/coalescable
	 * 2=Non-cacheable memory
	 * 4=cacheable, write-back, write-allocate memory (shared)
	 * 5=cacheable, write-through, no-write-allocate memory (shared)
	 * 6=cacheable, non-shared, write-back, write allocate memory
	 * 7=cacheable, non-shared, write-through, no-write-allocate
	 */


//NDS32_SR_DMA_ISADDR,	uDMA channel
	/* Nlocal memory}l}Aalign transfer element sizeACǿ鳣|ܦ}
	 * Ҧp4KB local memoryAiȪdOBITS(11,0)ApGOdouble bufferAiBITS(10,0)
	 * pG}W[WXɡA| Out-Of-Range errorAyoffset 0Ʒl
	 * pGDMA]stop/errorӰFAoӦ}|sJ~ǿ骺}
	 * bDMA run/pendedAgJȦsA|yDMA Transfer Disruption error
	 */

//NDS32_SR_DMA_ESADDR,	uDMA channel
	/* Nexternal memory}l}Aalign transfer element sizeACǿ鳣|ܦ}
	 * pGDMA]stop/errorӰFAoӦ}|sJ~ǿ骺}
	 * b1D transferA~}OWǿ}[WESTR
	 * b2D transferAJrowɡAWǿ}[Wheight strideFOrowAhOWǿ}[WESTR
	 */

//NDS32_SR_DMA_TCNT,	uDMA channel
	// Nnǿ骺elementƶqAbrunɤ|sAbstop/errorӰA|sJѾlelementƶqAҥHǿ駹AӬ0

//NDS32_SR_DMA_STATUS,	(read only) uDMA channelAresetRO|MAADMAAܻPŪȤݭnDSB
#define F_dma_state		BITS(2,0)	// ثechannelA: 0=idle, 1=run, 2=pended, 3=stop/error, 4=complete
#define F_dma_stuna		BITS(3,3)	// 1=Un-aligned error has happened on the External Stride value
#define F_dma_derr		BITS(4,4)	// 1=DMA Transfer Disruption Error
#define F_dma_euna		BITS(5,5)	// 1=Un-aligned error has happened on the External address
#define F_dma_iuna		BITS(6,6)	// 1=Un-aligned error has happened on the Internal address
#define F_dma_ioor		BITS(7,7)	// 1=Our-Of-Range error has happened on the Internal address
#define F_dma_ebus		BITS(8,8)	// 1=a Bus Error has happened on an External DMA transfer
#define F_dma_esup		BITS(9,9)	// 1=a DMA setup error has happenedAҦp2DSET.WECNTDMA_2DSCTL.STWECNT]0

//NDS32_SR_DMA_2DSET,	uDMA channelAݭn2D Element Transfer䴩
#define F_dma_2d_width	BITS(15,0)	// width element countA]1۷linearǿ
#define F_dma_2d_height	BITS(31,16)	// height stride
	/* bexternal memorywq@GϰAǿ@local memory
	 * }lǿ骺}ODMA_ESADDRACǿ駹@elementAN[WWidthStride
	 * Ĥ@ǿ駹StartupWidthCountelementADMA_ESADDR[WHeightStride
	 * Cǿ駹WidthCountelementADMA_ESADDR[WHeightStride
	 */

//NDS32_SR_DMA_2DSCTL	uDMA channelAݭn2D Element Transfer䴩
#define F_dma_2d_start	BITS(15,0)	// startup width element count
	/* DMA stopAȦs|sJCѾlWidthCountAϧڭ̥iH~ǿ
	 * gJWidthCountɡAPɤ]|gJȦs
	 */



/*
 * Resource Access Control
 */
//NDS32_SR_PRUSR_ACC_CTL	ݭn䴩performance monitorDMAAȦs~
#define F_user_dma		BITS(0,0)	// 1=User mode access of DMA registers and feature is allowed
#define F_user_pfm		BITS(1,1)	// 1=User mode access of Performance Monitoring registers and feature is allowed

//NDS32_SR_FUCOP_CTL		ݭn䴩COP/FPUaudio extensionAȦs~
#define F_cop0_en		BITS(0,0)	// 1=Coprocessor #0 enabled
#define F_cop1_en		BITS(1,1)	// 1=Coprocessor #1 enabled
#define F_cop2_en		BITS(2,2)	// 1=Coprocessor #2 enabled
#define F_cop3_en		BITS(3,3)	// 1=Coprocessor #3 enabled
#define F_audio_en		BITS(31,31)	// 1=Audio extension is enabled



/*
 * Miscellanaous Control
 */
//NDS32_SR_MISC_CTL,
#define F_misc_rtp		BITS(1,1)	// 1=disable return target predictor function (def=1)


#endif /* N903_REG_H_ */
