/*
 * fsm.h
 *
 *  Created on: 2014/4/7
 *      Author: 300210
 */

#ifndef FSM_H_
#define FSM_H_

#include "const.h"

/*
 * success_limit > 0: s@qɶis_success()Ǧ^trueANsuccess_state
 * success_limit <= 0: |is_success()Aû|success_state
 *
 * d1: timing stableɡAdbP@stateAunstableɡAinit_state
 *     is_success = isTimingStable();
 *     success_limit = 0;
 *     fail_limit = 50;
 *     fail_state = init_state;
 *     timeout_limit = 0;
 *
 * d2: ¥Ψdelay@qɶstate
 *     is_success = FSM_Dummy();
 *     success_limit = 0;
 *     fail_limit = 0;
 *     timeout_limit = 100;
 *     timeout_state = next_state;
 */
struct FSM_State {
	void (*entry_action)();
	bool (*is_success)();

	int success_limit;
	const FSM_State *success_state;
	void (*exit_success)();

	int fail_limit;
	const FSM_State *fail_state;
	void (*exit_fail)();

	int timeout_limit;
	const FSM_State *timeout_state;
	void (*exit_timeout)();
};

/*
 * FSMèSΤ@idAӬOpointerѧO
 * ҦpG
 *    FSM fsm_hdmi_init = {&fsm_hdmi_freqchk, ...};
 *    FSM fsm_hdmi_freqchk = {&fsm_hdmi_init, ...}
 */
class FSM_Object
{
public:
	const FSM_State *state;
	int success_time;
	int fail_time;
	int timeout_time;
	bool entry_done;

	/*
	 * Ystate
	 */
	void GoToState(const FSM_State *new_state);

	/*
	 * ΨӦbmain.cppwIsAstateʧ@
	 */
	void ProcState();
};
extern FSM_Object FSM;


extern void Dummy();
extern bool Always_True();
extern const FSM_State fsm_dummy;

#endif /* FSM_H_ */
