/*
 * reg_obj.h
 *
 *  Created on: 2014/2/16
 *      Author: 300210
 */

#ifndef REG_OBJ_H_
#define REG_OBJ_H_

#include "reg.h"


/*
 * TimerEvent: xsTimerƥoͪɶB欰
 */
struct TimerEvent
{
	void (*function)();		// TimerƥoͫAn檺禡APɤ]ΨӧP_ƥO_sb
	int type;				// PERIOD_TIMER: gʨƥ, ONCE_TIMER: @ʨƥ
	uint interval_ms;		// TimerϥΡANgʨƥ󪺶gA=ms
	int remain_ms;			// TimerϥΡANoӨƥٳѦh[n
};
enum EventType {
	PERIOD_TIMER,
	ONCE_TIMER,
};

/*
 * Timer
 *   ؿܡA@جOƥҦAHƥ󬰥DFt@إuΨө@pqɶ
 *   oؼҦVήɡA|ytimerVáAҥHĳV
 *   Timer1/2䴩_A~ϥΨƥҦ
 */
class Timer
{
private:
	uint id;
	TimerEvent event[5];	// ثew]us5Өƥ

public:
	// o̪"16"PU]wprescale
	static const int ms_count = CPU_FREQ / 16 / 1000;

	/*
	 * myID: wnϥΪTimerA1/2iHtimer event
	 * prescale@߳]16
	 */
	bool Init(uint myID);

	/*
	 * \Gwתɶ
	 * milli_seconds: 𪺮ɶ
	 */
	void Delay1ms(uint milli_seconds);

	/*
	 * \GsW@Өƥ
	 * myfunc: ƥoͫn檺禡
	 * type: PERIOD_TIMER: gʨƥ, ONCE_TIMER: @ʨƥ
	 * timeoutMS: jh[nƥ
	 */
	bool EventAdd (void (*myfunc)(), int type, int timeoutMS);

	/*
	 * \Gwƥ
	 * myfunc: MP禡ƥAòƥ
	 */
	bool EventRemove (void (*myfunc)());

	/*
	 * \GTimer1/2 _oͫA|Is禡BzƥAñNҦƥ󪺳ѾlɶgLɶ
	 */
	void HandleEvent ();

	/*
	 * \G]wgL@qɶoͤ_A]{bTimer1/2OHeventҦDAҥH禡Τ
	 * enable: 1=}_, 0=_
	 * msToTrigger: gLXms|Ĳo_
	 */
	void Interrupt_En (bool enable, uint msToTrigger);
};
extern Timer Timer1, Timer2, Timer3, Timer4;



/*
 * TX ϥΤk
 *   zL puts  printf LXT
 * RX ϥΤk
 *   RX_oͫAIs UART1.Enqueue(); Nfifoeƻsqueue
 *    while ((ch = UART1.getc()) != 0) ̧Ǩoqueuer
 */
class UART
{
private:
	uint id;
	static const int QUEUE_SIZE = 16;
	char queue[QUEUE_SIZE];
	int head, tail;
	uint baudRate;

public:
	/*
	 * \GlUARTó]wbaud rate
	 * myID: nϥΪUARTs
	 * setBaudRate: nϥΪbaud rate
	 */
	bool Init(uint myID, uint setBaudRate);

	/*
	 * parity: 0=disable, 1=odd, 2=even (default=0)
	 * stop: 0=1-bit, 1=2-bit (default=0)
	 * charlen: 0=5-bit, 1=6-bit, 2=7-bit, 3=8-bit (default=3)
	 */
	void SetProperties(int parity, int stop, int charlen);

	/*
	 * newBaudRate: ]wsbaud rate
	 */
	void SetBaudRate(uint newBaudRate);

	/*
	 * Xr
	 */
	void puts(const char *str);

	void putc(char ch);

	/*
	 * qqueueo@Ӧr
	 */
	char getc();

	/*
	 * NUARTfifoeƻsqueue
	 */
	void Enqueue();

	/*
	 * enable: }UART RX_
	 */
	void RxInt_En(bool enable);

	/*
	 * 䴩HU榡: %d, %u, %x, %X, %s, %c
	 */
	void printf (const char *fmt, ...);
};
extern UART UART1, UART2;



/*
 * Watchdog Timer
 *   1.Init(ms) ]wɶ
 *   2.Start() }lp
 *   3.Reset() wIsHmtimer
 */
class Watchdog
{
public:
	/*
	 * ]wn}ɶAprescale=16
	 */
	void Init(uint timeout);

	/*
	 * }lwatchdog timer
	 */
	void Start();

	/*
	 * nmwatchdog timerؤkAĤ@جO}timerAĤGجO]@timer count
	 * o̧ڭ̥βĤ@
	 * ĤGءGWDT_TIMER_CNT = WDT_TIMER_CNT;
	 */
	void Reset();
};
extern Watchdog WDT;



/*
 * Init(s, Wv(hz), duty): ]wWvå}PWM
 * Set(Wv(hz), duty): Wvduty
 * Enable(bool): }PWM
 */
class PWM
{
private:
	uint id;

public:
	static const uint MaxFreq = CPU_FREQ / 256 / 1;
	static const uint MinFreq = CPU_FREQ / 256 / 0x1FFF;

	void Set(uint freq_hz, uint duty_on_255);

	bool Init (uint myID, uint freq_hz, uint duty_on_255);

	void Enable(bool en);
};
extern PWM PWM1, PWM2, PWM3, PWM4;



/*
 * DDCCI: èSݭn]˪ܼơAuOFKzAN禡޲z
 * pG ParseWbuf() gӪAĳWߦ@Ө禡
 */
class DDCCI
{
public:
	bool Init ();

	/*
	 * enable: }Ū_APCŪƮɷ|Ĳo
	 */
	void ReadInt(bool enable);

	/*
	 * enable: }gJ_APCݼgJƮɷ|Ĳo
	 */
	void WriteInt(bool enable);

	/*
	 * ȮɱNDDC/CI parsero̡AHpGӪA]iHWߦ@Ө禡
	 * parserݭnDDC󪺤䴩
	 */
	void ParseWbuf();
};
extern DDCCI DDC;



/*
 * SPI module: i@master/slaveϥ
 * SPIǿ馳ؼҦ
 *   1.ug
 *   2.uŪ
 *   3.gŪ
 *   4.gŪAJdummy bytes
 *   5.Ūg
 *   6.ŪgAJdummy bytes
 *
 * FPGA connect lines:
 *     CS		J39.3-------J32.9
 *     MISO		J39.6-------J32.13
 *     CLK		J39.9-------J32.8
 *     MOSI		J39.12------J32.12
 */
#define SPI_SLAVE	true
#define SPI_MASTER	false
class SPI_Module
{
public:
	uint id;
	static const bool master = false;
	static const bool slave = true;
	bool isSlave;
	uint baudRate;

	/*
	 * myID: 0=SPI1, 1=SPI2, 䤤SPI1|QMCUΨŪcode
	 * slaveMode: 1=slave, 0=master
	 * myBaudRate: ]wt(Hz)
	 */
	uint Init(uint myID, bool slaveMode, uint myBaudRate);

	/*
	 * _oͫӲMAA_h|ױ᪺_
	 */
	void ClearInt();

	/*
	 * gJƨFIFOApGFIFOF|۰ʸX
	 */
	int WriteFIFO(const char *data, int len);

	/*
	 * qFIFOŪơAöǦ^Ū쪺(@w4)
	 */
	int Read(char *indata, int len);

	/*
	 * NƳzLSPIeX
	 */
	void Write(const char *outdata, int len);

	/*
	 * }SPI slaveQgJ\AmasterݥiHgJƶi
	 */
	void WaitForRead(int len);

	/*
	 * gŪApGdummylen0AN|Jdummy bytes
	 */
	int WriteRead(const char *outdata, int outlen, char *indata, int inlen, int dummylen);
};
extern SPI_Module SPI1, SPI2;



#define SPI_WREN		0x06
#define SPI_WRDI		0x04
#define SPI_RDID		0x9F
#define SPI_RDSR		0x05
#define SPI_WRSR		0x01
#define SPI_READ_CMD	0x03
#define SPI_FAST_READ	0x0B
#define SPI_SEC_ERASE	0x20	// a sector is 4KB in MX25L1005
#define SPI_PAGE_PROG	0x02	// a page is 256B

/*
 * oclassΨӴSPI flashsA]iHΨӧ@user datah
 * ϥΤk:
 *   1.lSPI1master: SPI1.Init(1, SPI_MASTER, 3000000);
 *   2.NSPI1wFlash: Flash.Init(&SPI1);
 *   3.char id[3]; Flash.ReadId(id); Ūid
 *   4.char str[256]; Flash.Read(0, str, 256); Ūw}
 *   5.char str[256]; Flash.FastRead(0, str, 256); ϥfast readŪ
 *   6.Flash.SectorErase(0); Mw}4KB (sectorjp]flashӲ)
 *   7.Flash.PageProgram(0, str, 256); gJw}256 bytes
 */
class SPI_Flash_Control
{
public:
	SPI_Module *spi;
	void Init(SPI_Module *spi_master);

	void ReadId(char *id);

	void Read(int address, char *data, int length);

	void FastRead(int address, char *data, int length);

	void WriteEn(bool enable);

	void SectorErase(int address);

	void PageProgram(int address, const char *data, int length);
};
extern SPI_Flash_Control Flash;



/*
 *    I2C Slave    I2C Master
 * SCL  J31.25      J31.23
 * SDA  J31.26      J31.24
 */
#define I2C_MASTER true
#define I2C_SLAVE false
/*
 * TestI2CRead, TestI2CWrite ONi2candes i2c slaveAզsregister
 * SlaveProcess i2c slaveΪA٨Sզ\
 */
class I2C_Module
{
public:
	bool master;
	uchar slaveAddress;

	void Init(bool masterMode, uchar slaveAddr);

	bool WaitForStatus(uint mask, uint status);

	void SlaveProcess();

	void Write(const char *data, int n);

	void WriteRead(const char *dataout, int n, char *datain, int inlen);

	// connect to i2c slave to read from
	uint TestI2CRead (uint address);

	bool TestI2CWrite(uint address, uint data);
};
extern I2C_Module I2C;

#endif /* REG_OBJ_H_ */
