/*
 * hdmi.cpp
 *
 *  Created on: 2014/4/7
 *      Author: 300210
 */
#include "reg_obj.h"
#include "hdmi.h"

bool hdmi_ok, hdmi_good, hdmi_stable;

void HDMI_Init()
{
	UART1.printf("HDMI_Init()\n");
}

bool HDMI_isInitOK()
{
	UART1.printf("isInitOK() ==> %d\n", hdmi_ok);
	return hdmi_ok;
}

void HDMI_Init_OK()
{
	UART1.printf("HDMI_Init_OK()\n");
}

void HDMI_Good()
{
	UART1.printf("HDMI_Good()\n");
}

bool HDMI_isGood()
{
	UART1.printf("isGood() ==> %d\n", hdmi_good);
	return hdmi_good;
}

void HDMI_Good_NotGood()
{
	UART1.printf("HDMI_Good_NotGood()\n");
}

void HDMI_Delay()
{
	UART1.printf("HDMI_Delay()\n");
}

void HDMI_Delay_Timeout()
{
	UART1.printf("HDMI_Delay_Timeout()\n");
}

void HDMI_Stable()
{
	UART1.printf("HDMI_Stable()\n");
}

bool HDMI_isStable()
{
	UART1.printf("HDMI_isStable() ==> %d\n", hdmi_stable);
	return hdmi_stable;
}

void HDMI_UnStable()
{
	UART1.printf("HDMI_UnStable()\n");
}


const FSM_State fsm_hdmi_init = {
	HDMI_Good, /* entry_action() */	HDMI_isInitOK, /* is_success() */

	1000, /* success_limit */	&fsm_hdmi_good, /* success_state */		HDMI_Init_OK, /* exit_success */
	0, /* fail_limit */			&fsm_dummy, /* fail_state */			Dummy, /* exit_fail */
	0, /* timeout_limit */		&fsm_dummy, /* timeout_state */			Dummy, /* exit_timeout */
};

const FSM_State fsm_hdmi_good = {
	HDMI_Init, /* entry_action() */	HDMI_isGood, /* is_success() */

	1000, /* success_limit */	&fsm_hdmi_delay, /* success_state */	Dummy, /* exit_success */
	2000, /* fail_limit */		&fsm_hdmi_init, /* fail_state */		HDMI_Good_NotGood, /* exit_fail */
	0, /* timeout_limit */		&fsm_dummy, /* timeout_state */			Dummy, /* exit_timeout */
};

const FSM_State fsm_hdmi_delay = {
	HDMI_Delay, /* entry_action() */	Always_True, /* is_success() */

	0, /* success_limit */		&fsm_dummy, /* success_state */			Dummy, /* exit_success */
	0, /* fail_limit */			&fsm_dummy, /* fail_state */			Dummy, /* exit_fail */
	3000, /* timeout_limit */	&fsm_hdmi_stable, /* timeout_state */	HDMI_Delay_Timeout, /* exit_timeout */
};

const FSM_State fsm_hdmi_stable = {
	HDMI_Stable, /* entry_action() */	HDMI_isStable, /* is_success() */

	0, /* success_limit */		&fsm_dummy, /* success_state */			Dummy, /* exit_success */
	500, /* fail_limit */		&fsm_hdmi_init, /* fail_state */		HDMI_UnStable, /* exit_fail */
	0, /* timeout_limit */		&fsm_dummy, /* timeout_state */			Dummy, /* exit_timeout */
};
