/*
 * interrupt.cpp
 *
 *  Created on: 2014/2/13
 *      Author: 300210
 *
 *  Ψө_Bz禡global C++ objects
 */

#include <ctype.h>
#include "reg.h"
#include "reg_obj.h"
#include "fsm.h"

/*
 * definitions of global C++ objects
 */
Timer Timer1, Timer2, Timer3, Timer4;
UART UART1, UART2;
Watchdog WDT;
PWM PWM1, PWM2, PWM3, PWM4;
DDCCI DDC;
SPI_Module SPI1, SPI2;
I2C_Module I2C;
SPI_Flash_Control Flash;
FSM_Object FSM;

void Handle_UART_Interrupt()
{
	char ch;
	/*
	 * We put all UART inputs to the queue, then we can use getc() to read the queue.
	 */
	UART1.Enqueue();
	while ((ch = UART1.getc()) != 0) {
		UART1.putc(ch);
		if (ch == '\r') UART1.putc('\n');

		extern bool hdmi_ok, hdmi_good, hdmi_stable;

		if (ch == '1') hdmi_ok = !hdmi_ok;
		if (ch == '2') hdmi_good = !hdmi_good;
		if (ch == '3') hdmi_stable = !hdmi_stable;
	}
}


void Handle_SPI_Interrupt()
{
}

/*
 * ]HW0_ISR|Qcrt0.SIsApGS[extern "C"Ablinksymbol name|HC++kRWAyLkIs
 */
extern "C"
void HW0_ISR()
{
	uint Int_Status = INT_STATUS1;	// this register is read-clear
	if (getbit(Int_Status, IRQ_TIMER))
	{
		Timer1.HandleEvent();
	}
	if (getbit(Int_Status, IRQ_TIMER2))
	{
		jitter_ms++;
	}
	if (getbit(Int_Status, IRQ_UART_RX))
	{
		Handle_UART_Interrupt();
	}
	if (getbit(Int_Status, IRQ_DDCCI_READ))
	{
		/*
		 * you must clear this bit to enable interrupt again
		 * if this bit keeps 1, all further interrupts would be blocked.
		 */
		setbit(DDC_INT_STATUS, F_ddc_rint, 1);
	}
	if (getbit(Int_Status, IRQ_DDCCI_WRITE))
	{
		DDC.ParseWbuf();
	}
	if (getbit(Int_Status, IRQ_SPI_MASTER))
	{
	}
	if (getbit(Int_Status, IRQ_I2C_MASTER))
	{
	}
}
