#define __MAIN__	// this macro must be before any including headers
#include "const.h"
#include "N903_reg.h"
#include "reg_obj.h"
#include "fsm.h"
#include "hdmi.h"

/*
 * TO DO LIST:
 * [x] SPI slave fifo հ_ӦD
 * [x] I2C slave ե
 */ 

class Seg7LED {
public:
	static int value;
	static const int seg7[];

	/*
	 * ϥ GPIO_C, GPIO_D ӱCqܾƦr
	 * } GPIO_C, GPIO_D output enable
	 */
	static bool Init ()
	{
		GPIO_C_OUTEN = 0xFF;
		GPIO_D_OUTEN = 0xFF;
		SetValue(0);
		return true;
	}

	/*
	 * x: nܪƭȡA|ഫ16i00~FF
	 */
	static void SetValue(unsigned int x)
	{
		value = x % 256;
		GPIO_C_DATA = 0x80 | seg7[x % 16];
		GPIO_D_DATA = 0x80 | seg7[x / 16];
	}

	/*
	 * ϥثeܪƭȥ[1
	 */
	static void increase ()
	{
		SetValue (value+1);
	}
};
const int Seg7LED::seg7[] = {0x40, 0x79, 0x24, 0x30, 0x19, 0x12, 0x02, 0x78, 0x00, 0x10, 0x08, 0x03, 0x46, 0x21, 0x06, 0x0E};
int Seg7LED::value = 0;

#if 0
/*
 * 禡ΨӦLXAndes CPU\
 */
void DebugConfig()
{
	uint cpu, icm, dcm, mmu, misc, core, fpu, ilm, dlm, psw;
	cpu = N903_Read(NDS32_SR_CPU_VER);
	icm = N903_Read(NDS32_SR_ICM_CFG);
	dcm = N903_Read(NDS32_SR_DCM_CFG);
	mmu = N903_Read(NDS32_SR_MMU_CFG);
	misc = N903_Read(NDS32_SR_MSC_CFG);
	core = N903_Read(NDS32_SR_CORE_ID);
	psw = N903_Read(NDS32_SR_PSW);
	if (getbit(cpu,F_cpu_has_fpu)) fpu = N903_Read(NDS32_SR_FUCOP_EXIST);
	if (getbit(icm,F_icm_ilmb)) ilm = N903_Read(NDS32_SR_ILMB);
	if (getbit(dcm,F_dcm_dlmb)) dlm = N903_Read(NDS32_SR_DLMB);

	UART1.puts("PSW:\n");
	UART1.printf("\tenable all interrupt %d\n", getbit(psw,F_psw_gie));
	UART1.printf("\tinterrupt stack level %d\n", getbit(psw,F_psw_intl));
	UART1.printf("\tprocessor operation mode %d\n", getbit(psw,F_psw_pom));
	UART1.printf("\tbig endian mode %d\n", getbit(psw,F_psw_be));
	UART1.printf("\tenable instruction address translation %d\n", getbit(psw,F_psw_it));
	UART1.printf("\tenable data address translation %d\n", getbit(psw,F_psw_dt));
	UART1.printf("\tinstruction machine error exception %d\n", getbit(psw,F_psw_ime));
	UART1.printf("\tdata machine error exception %d\n", getbit(psw,F_psw_dme));
	UART1.printf("\tdebug exception %d\n", getbit(psw,F_psw_dex));
	UART1.printf("\tdevice register big endian %d\n", getbit(psw,F_psw_dev_be));
	UART1.printf("\twrite back memory with no-write-allocation policy %d\n", getbit(psw,F_psw_wbna));

	UART1.puts("CPU_VER:\n");
	UART1.printf("\tperformance extension exists %d\n", getbit(cpu,F_cpu_perf_ext));
	UART1.printf("\t16-bit extension exists %d\n", getbit(cpu,F_cpu_16_ext));
	UART1.printf("\tperformance extension 2 exists %d\n", getbit(cpu,F_cpu_perf2_ext));
	UART1.printf("\tCOP/FPU extension exists %d\n", getbit(cpu,F_cpu_has_fpu));
	UART1.printf("\tstring extension exists %d\n", getbit(cpu,F_cpu_str_ext));
	UART1.printf("\tcpu revision = %x, cpu id = %x\n", getbit(cpu,F_cpu_rev), getbit(cpu,F_cpu_id));

	UART1.puts("ICM_CFG:\n");
	UART1.printf("\tIcache cachelines per way %d\n", getbit(icm,F_icm_iset));
	UART1.printf("\tIcache ways %d\n", getbit(icm,F_icm_iway));
	UART1.printf("\tIcache line size %d\n", getbit(icm,F_icm_isize));
	UART1.printf("\tsupport locking %d\n", getbit(icm,F_icm_lock));
	UART1.printf("\tnum of on-chip instruction local memory base %d\n", getbit(icm,F_icm_ilmb));
	UART1.printf("\tILM base alignment %d\n", getbit(icm,F_icm_align));

	UART1.puts("DCM_CFG:\n");
	UART1.printf("\tDcache cachelines per way %d\n", getbit(dcm,F_dcm_dset));
	UART1.printf("\tDcache ways %d\n", getbit(dcm,F_dcm_dway));
	UART1.printf("\tDcache line size %d\n", getbit(dcm,F_dcm_dsize));
	UART1.printf("\tsupport locking %d\n", getbit(dcm,F_dcm_lock));
	UART1.printf("\tnum of on-chip data local memory base %d\n", getbit(dcm,F_dcm_dlmb));
	UART1.printf("\tDLM base alignment %d\n", getbit(dcm,F_dcm_align));
	UART1.printf("\texternal DLM %d\n", getbit(dcm,F_dcm_extdlm));

	UART1.puts("MMU_CFG:\n");
	UART1.printf("\tmemory management %d\n", getbit(mmu,F_mmu_func));
	UART1.printf("\tversion number of the MMU protection scheme %d\n", getbit(mmu,F_mmu_pro_ver));
	UART1.printf("\tTLB is a full-associative structure %d\n", getbit(mmu,F_mmu_ful_tlb));
	if (getbit(mmu,F_mmu_ful_tlb)) {
		UART1.printf("\tthe number of TLB entries %d\n", getbit(mmu,F_mmu_tlb_size));
	} else {
		UART1.printf("\t0=direct-mapped, 1~7=2~8 ways %d\n", getbit(mmu,F_mmu_tlb_ways));
		UART1.printf("\t0~6=4~256 sets per way %d\n", getbit(mmu,F_mmu_tlb_sets));
	}
	UART1.printf("\tunder 4kb config, 1=support 8kb page %d\n", getbit(mmu,F_mmu_8kb_page));
	UART1.printf("\tsupported page sizes %02x\n", getbit(mmu,F_mmu_page_size));
	UART1.printf("\tTLB locking support %d\n", getbit(mmu,F_mmu_tlb_lock));
	UART1.printf("\thardware page table walker %d\n", getbit(mmu,F_mmu_hw_tblwalk));
	UART1.printf("\tdefault endian %d\n", getbit(mmu,F_mmu_def_be));
	UART1.printf("\tnumber of partition for non-translated attributes %d\n", getbit(mmu,F_mmu_nta_num));
	UART1.printf("\tsoftware-invisible TLB that includes additional PTEs exists %d\n", getbit(mmu,F_mmu_inv_tlb));
	UART1.printf("\tVLPT feature is implemented, for fast TLB fill handling %d\n", getbit(mmu,F_mmu_vplt));
	UART1.printf("\timplement non-translated VA to PA mapping function %d\n", getbit(mmu,F_mmu_nta_map));
	UART1.printf("\tdevice register default endian %d\n", getbit(mmu,F_mmu_dev_def_be));

	UART1.puts("MSC_CFG:\n");
	UART1.printf("\tembedded debug module is implemented %d\n", getbit(misc,F_msc_edm));
	UART1.printf("\tlocal memory DMA is implemented %d\n", getbit(misc,F_msc_dma));
	UART1.printf("\tperformance monitoring machanism is implemented %d\n", getbit(misc,F_msc_mon));
	UART1.printf("\thigh speed memory port exists %d\n", getbit(misc,F_msc_hs_mem));
	UART1.printf("\tdebug tracer unit is implemented %d\n", getbit(misc,F_msc_trace));
	UART1.printf("\tDIV/DIVS instruction exists %d\n", getbit(misc,F_msc_div));
	UART1.printf("\tmultiply instruction exists %d\n", getbit(misc,F_msc_mul));
	UART1.printf("\taudio extension %d\n", getbit(misc,F_msc_audio));
	UART1.printf("\tL2 unified cache is implemented %d\n", getbit(misc,F_msc_l2c));
	UART1.printf("\treduced register config is implemented %d\n", getbit(misc,F_msc_gpr16));
	UART1.printf("\treduced address space to 24-bit %d\n", getbit(misc,F_msc_adr24));
	UART1.printf("\tint level 1~2 is implemented %d\n", getbit(misc,F_msc_intlc));
	UART1.printf("\tversion of baseline %d\n", getbit(misc,F_msc_basev));
	UART1.printf("\tDx register exist %d\n", getbit(misc,F_msc_nod));
	UART1.printf("\timplementation-dependent register detection scheme %d\n", getbit(misc,F_msc_depreg));
	UART1.printf("\tthe first implementation-dependent register exists %d\n", getbit(misc,F_msc_ownreg));
	UART1.printf("\tInline Function Call (IFC) supported %d\n", getbit(misc,F_msc_ifc));
	UART1.printf("\tThis processor belongs to MCU family %d\n", getbit(misc,F_msc_mcu));
	UART1.printf("\tOne shadow stack pointer for privileged mode %d\n", getbit(misc,F_msc_shadow));

	if (getbit(icm,F_icm_ilmb))
	{
		UART1.puts("ILMB:\n");
		UART1.printf("\tenable instruction local memory %d\n", getbit(ilm,F_ilmb_en));
		UART1.printf("\t0~8=size 4KB~1024KB %d\n", getbit(ilm,F_ilmb_size));
		UART1.printf("\tbase physical address of ILM %x\n", getbit(ilm,F_ilmb_ibpa));
	}

	if (getbit(dcm,F_dcm_dlmb))
	{
		UART1.puts("DLMB:\n");
		UART1.printf("\tenable data local memory %d\n", getbit(dlm,F_dlmb_en));
		UART1.printf("\t0~8=size 4KB~1024KB %d\n", getbit(dlm,F_dlmb_size));
		UART1.printf("\tenable double buffer mode %d\n", getbit(dlm,F_dlmb_2buf));
		UART1.printf("\twhich bank of double buffer is used by processor %d\n", getbit(dlm,F_dlmb_dbb));
		UART1.printf("\tbase physical address of DLM %x\n", getbit(dlm,F_dlmb_dpba));
	}
}
#endif


void Initialize()
{
	// Seg7LED: CqܾAϥ GPIO_C, GPIO_D ӱCqܾƦr
	Seg7LED::Init();

	// lUART1A~iH}lLT
	UART1.Init(1, 115200);
	UART1.RxInt_En(true);

	UART1.puts("Compile Time " __TIME__ " On " __DATE__  "\n");
//	DebugConfig();

	// Timer1ĥevent覡AN Seg7LED::increase [Jeventó]C1000ms
	Timer1.Init(1);
	Timer1.EventAdd(Seg7LED::increase, PERIOD_TIMER, 1000);

	// Timer2ΨӺ@jitter_ms
	Timer2.Init(2);

	// Watchdog Timer]w5000msm@
	WDT.Init(5000);
	WDT.Start();

	// Init (s, Wv(:hz), Duty(̤j255))
	PWM1.Init (1, 1000, 64);
	PWM2.Init (2, 2000, 128);
	PWM3.Init (3, 3000, 192);
	PWM4.Init (4, 4000, 128);

	// lDDCCIAå}write interrupt
	DDC.Init();

	// ΨӴAPB busWSPI
	// SPI1PɱAHBWACPUŪ{XFSPI2uAPBW
	SPI1.Init(1, SPI_MASTER, 3000000);
	SPI2.Init(2, SPI_SLAVE, 3000000);

	// ϥSPI1Flash
	Flash.Init(&SPI1);

	// I2C master
	I2C.Init(I2C_MASTER, 0);
	UART1.printf("read timer base = %x\n", I2C.TestI2CRead(0x90010000));
}

int main()
{
	Initialize();

	FSM.GoToState(&fsm_hdmi_init);

	while(true)
	{
		// ˬdO_Jtouch keyIR
		// ProcKey()

		// BzOSDƥ
		// ProcOSD()

		// BzUserƥ
		// ProcUser()

		// _ӳBzӦhƱAHKɶӪAɥi]w@flagAæbo̰
		// ProcLateInt()

		// M/]wsourceo
		FSM.ProcState();

		WDT.Reset();
	}
	return 0;
}
